using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.IO;
using System.Xml;

namespace blogapi
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            this.Enabled = false;
            this.Visible = false;
            back = new pozadi();
            back.Owner = this;
            back.label1.Text = "Language loading";
            back.Show();

            nast = new nastaveni(this);

            back.label1.Text = nast.getlang("loading");

            Application.DoEvents();

            str = new pages(nast);
            pb = new publy(str,nast);
            pris = new novyprispevek(pb,nast,str);

            InitializeComponent();
            setlang();

            if (nast.prvnispusteni)
            {
                back.label1.Text = nast.getlang("firsttime");
                MessageBox.Show(nast.getlang("uvitanispusteni"), nast.getlang("firsttime"));
                nast.generuj();
                nast.ShowDialog();
            }
        }

        pozadi back;

        //konec aplikace
        private void button5_Click(object sender, EventArgs e)
        {
            if (DialogResult.Yes == MessageBox.Show(nast.getlang("dotazvypnuti"), nast.getlang("konec"), MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1))
            {
                uloz();
                Application.Exit();
            }
        }

        //nov pspvek
        novyprispevek pris;
        private void button1_Click(object sender, EventArgs e)
        {
            pris.nastav(-1,nast.autobr);
            pris.Show();
        }

        //publikace
        publy pb;
        private void button2_Click(object sender, EventArgs e)
        {
            pb.vypis(true);
            pb.Show();
        }

        //sprva t
        pages str;
        private void button4_Click(object sender, EventArgs e)
        {
            str.nacti();
            str.Show();
        }

        //vypnut background
        private void Form1_Load(object sender, EventArgs e)
        {
            this.Visible = true;
            this.Enabled = true;
            back.Close();
            back = null;
        }

        //nastaven
        nastaveni nast;
        private void button3_Click(object sender, EventArgs e)
        {
            nast.generuj();
            nast.Show();
        }

        //uloen
        public void uloz()
        {
            while (true)
            {
                try
                {
                    if (nast.typzapisu == 0)
                    {
                        FileStream zap = new FileStream(nast.nachazitese + "/soubory.db", FileMode.Create);
                        BinaryWriter pis = new BinaryWriter(zap, Encoding.UTF8);
                        for (int i = 0; i < pb.prispevkypole.Count; i++)
                        {
                            prispevek pris = (prispevek)pb.prispevkypole[i];
                            pis.Write(pris.titulek);
                            pis.Write(pris.text);
                            pis.Write(pris.datum.Ticks);
                            pis.Write(pris.kate());
                        }
                        pis.Flush();
                        zap.Flush();
                        pis.Close();
                        zap.Close();

                        zap = new FileStream(nast.nachazitese+"/ucty.db", FileMode.Create);
                        pis = new BinaryWriter(zap, Encoding.UTF8);
                        for (int i = 0; i < str.mozn.Count; i++)
                        {
                            blogs bl = (blogs)str.mozn[i];
                            pis.Write(bl.user);
                            pis.Write(bl.sifruj());
                            pis.Write(bl.url);
                            pis.Write(bl.type);
                            pis.Write(bl.vybrat);
                            pis.Write(bl.kategorietostring());
                        }
                        pis.Flush();
                        zap.Flush();
                        pis.Close();
                        zap.Close();

                        zap = new FileStream(nast.nachazitese + "/nastaveni.db", FileMode.Create);
                        pis = new BinaryWriter(zap, Encoding.UTF8);
                        pis.Write(nast.typzapisu);
                        pis.Write(nast.debugmode);
                        pis.Write(nast.automazat);
                        pis.Write(nast.autobr);
                        pis.Write(nast.language.Name);
                        pis.Write(nast.autokatdown);
                        pis.Write(nast.sifrovani);
                        pis.Flush();
                        zap.Flush();
                        pis.Close();
                        zap.Close();

                        if (File.Exists(nast.nachazitese + "/data.xml"))
                        {
                            try
                            {
                                File.Delete(nast.nachazitese + "/data.xml");
                            }
                            catch
                            {
                                MessageBox.Show(nast.getlang("chybacisteni"),nast.getlang("chyba"));
                            }
                        }
                    }
                    else
                    {
                        FileStream zaps = new FileStream(nast.nachazitese + "/data.xml", FileMode.Create);
                        TextWriter texts = new StreamWriter(zaps, Encoding.UTF8);
                        XmlTextWriter zapis = new XmlTextWriter(texts);
                        zapis.Formatting = Formatting.Indented;
                        zapis.WriteStartDocument();
                        zapis.WriteStartElement("data");
                        zapis.WriteStartElement("posts");
                        for (int i = 0; i < pb.prispevkypole.Count; i++)
                        {
                            prispevek pris = (prispevek)pb.prispevkypole[i];
                            zapis.WriteStartElement("post");
                            zapis.WriteElementString("title", pris.titulek);
                            zapis.WriteElementString("text", pris.text);
                            zapis.WriteElementString("date", pris.datum.Ticks.ToString());
                            zapis.WriteElementString("categories", pris.kate());
                            zapis.WriteEndElement();
                        }
                        zapis.WriteEndElement();
                        zapis.WriteStartElement("servers");
                        for (int i = 0; i < str.mozn.Count; i++)
                        {
                            blogs bl = (blogs)str.mozn[i];
                            zapis.WriteStartElement("server");
                            zapis.WriteElementString("user", bl.user);
                            zapis.WriteElementString("url", bl.url);
                            if (nast.sifrovani)
                            {
                                zapis.WriteElementString("passenc", bl.sifruj());
                            }
                            else
                            {
                                zapis.WriteElementString("pass", bl.pass);
                            }
                            zapis.WriteElementString("type", bl.type.ToString());
                            zapis.WriteElementString("chose", bl.vybrat.ToString());
                            if (bl.kategorie.Count != 0)
                            {
                                zapis.WriteStartElement("cats");
                                for (int p = 0; p < bl.kategorie.Count; p++)
                                {
                                    zapis.WriteElementString("cat", bl.kategorie[p].ToString());
                                }
                                zapis.WriteEndElement();
                            }
                            zapis.WriteEndElement();
                        }
                        zapis.WriteEndElement();
                        zapis.WriteStartElement("options");
                            zapis.WriteElementString("readtype", nast.typzapisu.ToString());
                            zapis.WriteElementString("debugmode", nast.debugmode.ToString());
                            zapis.WriteElementString("autodelete", nast.automazat.ToString());
                            zapis.WriteElementString("autobr", nast.autobr.ToString());
                            zapis.WriteElementString("language", nast.language.Name);
                            zapis.WriteElementString("question", nast.dotazovatse.ToString());
                            zapis.WriteElementString("autocatsdown", nast.autokatdown.ToString());
                            zapis.WriteElementString("encription", nast.sifrovani.ToString());
                        zapis.WriteEndElement();
                        zapis.WriteEndElement();
                        zapis.Flush();
                        zapis.Close();
                        //texts.Flush();
                        texts.Close();
                        //zaps.Flush();
                        zaps.Close();
                        if (File.Exists(nast.nachazitese + "/nastaveni.db"))
                        {
                            try
                            {
                                File.Delete(nast.nachazitese + "/nastaveni.db");
                            }
                            catch
                            {
                                MessageBox.Show(nast.getlang("chybacisteni"), nast.getlang("chyba"));
                            }
                        }
                    }

                    break;
                }
                catch
                {
                    if (DialogResult.Cancel == MessageBox.Show(nast.getlang("ulozeniselhalo"), nast.getlang("chybaaplikace"), MessageBoxButtons.RetryCancel, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1))
                    {
                        break;
                    }
                }
            }
        }

        //ukldn a uzavrn
        private void Form1_Closing(object sender, CancelEventArgs e)
        {
            if (DialogResult.Yes == MessageBox.Show(nast.getlang("dotazvypnuti"), nast.getlang("konec"), MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1))
            {
                e.Cancel = false;
                uloz();
            }
            else
            {
                e.Cancel = true;
            }
        }

        //zobrazen informac o autorech
        private void pictureBox1_Click(object sender, EventArgs e)
        {
            autori aut = new autori(nast);
            aut.ShowDialog();
            aut = null;
        }

        //obnova jazykovho rozhran
        public void refreshlang()
        {
            nast.refreshlang();
            setlang();
            pris.setlang();
            str.setlang();
            pb.setlang();
        }

        //nastaven jazykovho rozhran mainu
        private void setlang()
        {
            button1.Text = nast.getlang("newpost");
            button2.Text = nast.getlang("publikace");
            button3.Text = nast.getlang("nastavenimain");
            button4.Text = nast.getlang("spravauctu");
            button5.Text = nast.getlang("konec");
            label2.Text = nast.getlang("forwm");
        }
    }
}